Index: /branches/new_class_id/src/lib/graphics/text_engine/font.cc
===================================================================
--- /branches/new_class_id/src/lib/graphics/text_engine/font.cc	(revision 9722)
+++ /branches/new_class_id/src/lib/graphics/text_engine/font.cc	(revision 9723)
@@ -132,5 +132,5 @@
 
   this->registerObject(this, Font::_objectList);
-  if (Font::defaultFontData.get() == NULL)
+  if (Font::defaultFontData.isNull())
   {
     Font::initDefaultFont();
Index: /branches/new_class_id/src/lib/util/count_pointer.h
===================================================================
--- /branches/new_class_id/src/lib/util/count_pointer.h	(revision 9722)
+++ /branches/new_class_id/src/lib/util/count_pointer.h	(revision 9723)
@@ -9,48 +9,54 @@
 {
 public:
-    explicit CountPointer(X* p = 0) // allocate a new counter
-        : itsCounter(0) { if (p) itsCounter = new counter(p); }
-    virtual ~CountPointer() { release(); }
-    CountPointer(const CountPointer& r) { acquire(r.itsCounter); }
-    CountPointer& operator=(const CountPointer& r)
+  explicit CountPointer(X* p = NULL) // allocate a new counter
+      : itsCounter(NULL) { if (p) itsCounter = new counter(p); }
+virtual ~CountPointer() { release(); }
+  CountPointer(const CountPointer& r) { acquire(r.itsCounter); }
+  CountPointer& operator=(const CountPointer& r)
+  {
+    if (this != &r)
     {
-        if (this != &r) {
-            release();
-            acquire(r.itsCounter);
-        }
-        return *this;
+      release();
+      acquire(r.itsCounter);
     }
-    bool operator==(const CountPointer& r) const { return this->itsCounter->ptr == r.itsCounter->ptr; };
-    X& operator*()  const { return *itsCounter->ptr; }
-    X* operator->() const { return itsCounter->ptr; }
-    X* get()        const { return itsCounter ? itsCounter->ptr : 0; }
-    bool unique()   const { return (itsCounter ? itsCounter->count == 1 : true); }
-    virtual unsigned int count() const { return (this->itsCounter ? itsCounter->count : 0); }
+    return *this;
+  }
+  bool operator==(const CountPointer& r) const { return this->itsCounter->ptr == r.itsCounter->ptr; };
+  inline X& operator*()  const { return *itsCounter->ptr; }
+  inline X* operator->() const { return itsCounter->ptr; }
+inline bool unique()   const { return (itsCounter ? itsCounter->count == 1 : true); }
+  inline bool isNull()   const { return (!itsCounter); }
+
+virtual unsigned int count() const { return (this->itsCounter ? itsCounter->count : 0); }
 private:
 
-    struct counter {
-        counter(X* p = 0, unsigned c = 1) : ptr(p), count(c) {}
-        X*          ptr;
-        unsigned    count;
-    }* itsCounter;
+  struct counter
+  {
+    counter(X* p = NULL, unsigned c = 1) : ptr(p), count(c) {}
+    X*          ptr;
+    unsigned    count;
+  }
+  * itsCounter;
 
-    void acquire(counter* c)
+  void acquire(counter* c)
+  {
+    // increment the count
+    itsCounter = c;
+    if (c) ++c->count;
+  }
+
+  void release()
+  {
+    // decrement the count, delete if it is 0
+    if (itsCounter)
     {
-      // increment the count
-        itsCounter = c;
-        if (c) ++c->count;
+      if (--itsCounter->count == 0)
+      {
+        delete itsCounter->ptr;
+        delete itsCounter;
+      }
+      itsCounter = NULL;
     }
-
-    void release()
-    {
-      // decrement the count, delete if it is 0
-        if (itsCounter) {
-            if (--itsCounter->count == 0) {
-                delete itsCounter->ptr;
-                delete itsCounter;
-            }
-            itsCounter = 0;
-        }
-    }
+  }
 };
 
Index: /branches/new_class_id/src/story_entities/game_world.cc
===================================================================
--- /branches/new_class_id/src/story_entities/game_world.cc	(revision 9722)
+++ /branches/new_class_id/src/story_entities/game_world.cc	(revision 9723)
@@ -415,5 +415,5 @@
     if (currentFrame - this->lastFrame < .01)
     {
-      SDL_Delay(1000.0 * (0.01 - (currentFrame - lastFrame)));
+      SDL_Delay((int)1000.0 * (0.01 - (currentFrame - lastFrame)));
       currentFrame = Timer::getNow();
     }
Index: /branches/new_class_id/src/world_entities/weapons/weapon.cc
===================================================================
--- /branches/new_class_id/src/world_entities/weapons/weapon.cc	(revision 9722)
+++ /branches/new_class_id/src/world_entities/weapons/weapon.cc	(revision 9723)
@@ -542,5 +542,5 @@
 {
   PRINTF(4)("Reloading Weapon %s\n", this->getCName());
-  if (this->ammoContainer.get() != NULL &&
+  if (!this->ammoContainer.isNull() &&
       unlikely(this->energy + this->ammoContainer->getStoredEnergy() < this->minCharge))
   {
@@ -554,5 +554,5 @@
     this->soundSource->play(this->soundBuffers[WA_RELOAD]);
 
-  if (this->ammoContainer.get() != NULL)
+  if (!this->ammoContainer.isNull())
     this->ammoContainer->fillWeapon(this);
   else