Index: /branches/new_class_id/src/lib/lang/object_list.cc
===================================================================
--- /branches/new_class_id/src/lib/lang/object_list.cc	(revision 9725)
+++ /branches/new_class_id/src/lib/lang/object_list.cc	(revision 9726)
@@ -19,7 +19,4 @@
 #include <cassert>
 
-
-#include <stdio.h>
-
 /**
  * @brief Constructor, that creates an ObjectList while checking (development mode) for uniqueness of all Keys (names and ID's)
@@ -33,7 +30,7 @@
   if (ObjectListBase::_classesByID == NULL)
   {
-    ObjectListBase::_classesByID = new classIDMap;
+    ObjectListBase::_classesByID = new IDMap;
     assert (ObjectListBase::_classesByName == NULL);
-    ObjectListBase::_classesByName = new classNameMap;
+    ObjectListBase::_classesByName = new NameMap;
   }
   assert(!ObjectListBase::classNameExists(className) && "Classes should only be included once, and no two classes should have the same name (key value)");
@@ -83,6 +80,6 @@
 }
 
-ObjectListBase::classIDMap* ObjectListBase::_classesByID = NULL;
-ObjectListBase::classNameMap* ObjectListBase::_classesByName = NULL;
+ObjectListBase::IDMap* ObjectListBase::_classesByID = NULL;
+ObjectListBase::NameMap* ObjectListBase::_classesByName = NULL;
 std::list<std::string> ObjectListBase::_classNames;
 
@@ -156,5 +153,5 @@
 {
   assert (ObjectListBase::_classesByID != NULL);
-  ObjectListBase::classIDMap::iterator it = ObjectListBase::_classesByID->find(classID);
+  ObjectListBase::IDMap::iterator it = ObjectListBase::_classesByID->find(classID);
   if (it != ObjectListBase::_classesByID->end())
     return (*it).second;
@@ -171,5 +168,5 @@
 {
   assert (ObjectListBase::_classesByName != NULL);
-  ObjectListBase::classNameMap::iterator it = ObjectListBase::_classesByName->find(className);
+  ObjectListBase::NameMap::iterator it = ObjectListBase::_classesByName->find(className);
   if (it != ObjectListBase::_classesByName->end())
     return (*it).second;
@@ -243,10 +240,8 @@
     ObjectListBase::_classNames.clear();
 
-    for (classNameMap::const_iterator it = ObjectListBase::_classesByName->begin();
-	 it != ObjectListBase::_classesByName->end();
-	 ++it)
-    {
+    for (NameMap::const_iterator it = ObjectListBase::_classesByName->begin();
+         it != ObjectListBase::_classesByName->end();
+         ++it)
       ObjectListBase::_classNames.push_back((*it).second->name());
-    }
   }
   return ObjectListBase::_classNames;
@@ -294,12 +289,8 @@
   printf("Listing all %d ObjectLists \n", ObjectListBase::_classesByID->size());
 
-  for (classNameMap::const_iterator it = ObjectListBase::_classesByName->begin();
+  for (NameMap::const_iterator it = ObjectListBase::_classesByName->begin();
        it != ObjectListBase::_classesByName->end();
        ++it)
-  {
     (*it).second->debug(level);
-
-  }
-
 }
 
@@ -339,3 +330,2 @@
     return -1;
 }
-
Index: /branches/new_class_id/src/lib/lang/object_list.h
===================================================================
--- /branches/new_class_id/src/lib/lang/object_list.h	(revision 9725)
+++ /branches/new_class_id/src/lib/lang/object_list.h	(revision 9726)
@@ -9,8 +9,9 @@
 
 #include "class_id.h"
-#include <cassert>
 #include <map>
 #include <list>
 #include <string>
+
+#include <cassert>
 #include <iostream>
 
@@ -101,5 +102,5 @@
   static int                            StringToID(const std::string& className);
 
-  //! Only uset to unsubscribe a BaseObject.
+  //! Only used to unsubscribe a BaseObject. (just try to make a valid iterator, stupid :))
   virtual void                          unregisterObject(IteratorBase* _iterators) = 0;
 
@@ -117,6 +118,6 @@
 
 protected:
-  typedef std::map<int, ObjectListBase*>         classIDMap;   //!< The Generic Map.
-  typedef std::map<std::string, ObjectListBase*> classNameMap; //!< The Generic Map.
+  typedef std::map<int, ObjectListBase*>         IDMap;   //!< The Generic Map.
+  typedef std::map<std::string, ObjectListBase*> NameMap; //!< The Generic Map.
 
 private:
@@ -126,6 +127,6 @@
 
 private:
-  static classIDMap*            _classesByID;       //!< A Map of all the classes in existance.
-  static classNameMap*          _classesByName;     //!< A Map of all the classes in existance.
+  static IDMap*                 _classesByID;       //!< A Map of all the classes in existance.
+  static NameMap*               _classesByName;     //!< A Map of all the classes in existance.
   static std::list<std::string> _classNames;        //!< A list of all the registered ClassNames.
 };
@@ -135,14 +136,15 @@
 //// TEMPLATISATION /////
 /////////////////////////
-//! Defines a ObjectsList handler for objects of type T.
+//! Defines a ObjectList handler for objects of type T.
 /**
  * The ObjectList is a generic way to store every object created from a Class 'T'
- *  into a List. The list can be retrieved, and used constantly over iterators,
+ *  in a List. The list can be retrieved, and used constantly over iterators,
  *  as with normal std::list.
  *
  * Furthermore the linkage over the single Lists is given over the Superclass ObjectListBase.
  *
- *
- *
+ * The approach of ObjectList is an intrusive one, meaning, that each Class that wants to
+ * support it must implement a Declaration and a Definition for the ObjectList, as mentioned
+ * in the next statement:
  *
  * To define a Class with a ObjectList, you have to:
@@ -152,4 +154,5 @@
  *
  * @note The Class must define the compare with const std::string& operator for this to work.
+ *  The operator==(const std::string& name) should compare the object's name with name.
  *
  *