Index: code/branches/levelMichael/data/levels/Spacefight.oxw
===================================================================
--- code/branches/levelMichael/data/levels/Spacefight.oxw	(revision 9737)
+++ code/branches/levelMichael/data/levels/Spacefight.oxw	(revision 9738)
@@ -229,4 +229,15 @@
         	</events>
         </QuestEffectBeacon>
+
+	<QuestEffectBeacon times=0>
+		<events>
+			<execute>
+				<EventListener event=spawntrigger2 />
+			</execute>
+		</events>
+		<attached>
+			<BlinkingBillboard position="18000, 5000, 21000" color="1,0,0" frequency=0.6 amplitude=10 material="Examples/Flare" />
+		</attached>
+	</QuestEffectBeacon>
 
 <!-- ---------------------------------------------------------------------- -->
@@ -276,9 +287,49 @@
     </EventTrigger>
 
+    <SimpleNotification message="first" >
+        <events>
+            <trigger>
+                <EventListener event="guard1trigger1" />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <SimpleNotification message="second" >
+        <events>
+            <trigger>
+                <EventListener event="guard1trigger2" />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <SimpleNotification message="third" >
+        <events>
+            <trigger>
+                <EventListener event="guard1trigger3" />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <SimpleNotification message="fourth" >
+        <events>
+            <trigger>
+                <EventListener event="guard1trigger4" />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <SimpleNotification message="shot" >
+        <events>
+            <trigger>
+                <EventListener event="firstPatrol" />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
 <!-- ----------------------------------------------------- -->
 
 <!-- Passive Piraten: Guard 1 -->
 
-<SpaceShip position="8000,1000,0" lookat="-1,0,0" name="firstPatrol" radarname="Patrol">
+<SpaceShip position="8000,1000,0" lookat="-1,0,0" name=firstPatrol radarname="Patrol">
   <events>
     <visibility>
@@ -292,6 +343,6 @@
     <WaypointController team=1>
       <waypoints>
-        <Model mesh="cube.mesh" scale=8 position="8000,-1000,0" />
-        <Model mesh="cube.mesh" scale=8 position="8000,1000,0" />
+        <Model mesh="cube.mesh" scale=0 position="8000,-1000,0" />
+        <Model mesh="cube.mesh" scale=0 position="8000,1000,0" />
       </waypoints>
     </WaypointController>
@@ -311,6 +362,6 @@
     <WaypointController team=1>
       <waypoints>
-        <Model mesh="cube.mesh" scale=8 position="8000,0,-1000" />
-        <Model mesh="cube.mesh" scale=8 position="8000,0,1000" />
+        <Model mesh="cube.mesh" scale=0 position="8000,0,-1000" />
+        <Model mesh="cube.mesh" scale=0 position="8000,0,1000" />
       </waypoints>
     </WaypointController>
@@ -333,6 +384,6 @@
     <WaypointPatrolController alertnessradius=2000 team=1 active=false>
       <waypoints>
-        <Model mesh="cube.mesh" scale=8 position="8000,1000,-1000" />
-        <Model mesh="cube.mesh" scale=8 position="8000,-1000,1000" />
+        <Model mesh="cube.mesh" scale=0 position="8000,1000,-1000" />
+        <Model mesh="cube.mesh" scale=0 position="8000,-1000,1000" />
       </waypoints>
       <events>
@@ -357,6 +408,6 @@
     <WaypointPatrolController alertnessradius=2000 team=1 active=false>
       <waypoints>
-        <Model mesh="cube.mesh" scale=8 position="8000,1000,1000" />
-        <Model mesh="cube.mesh" scale=8 position="8000,-1000,-1000" />
+        <Model mesh="cube.mesh" scale=0 position="8000,1000,1000" />
+        <Model mesh="cube.mesh" scale=0 position="8000,-1000,-1000" />
       </waypoints>
       <events>
@@ -369,7 +420,125 @@
 </SpaceShip>
 
-<!-- Passive Piraten: Guard 2 -->
-
 <!-- Angreiffende Piraten: Guard 2 -->
+<SpaceShip position="19000,5000,21000" lookat="19000,4900,21000" name=secondPatrol visible="true" radarname="Patrol">
+  <events>
+    <visibility>
+      <EventListener event=guard1trigger4 />
+    </visibility>
+  </events>
+  <templates>
+    <Template link=spaceshippirate />
+  </templates>
+  <controller>
+    <WaypointPatrolController alertnessradius=2000 team=1 active=false>
+      <waypoints>
+	<Model mesh="cube.mesh" scale=0 position="18700,4300,21000" />
+        <Model mesh="cube.mesh" scale=0 position="18000,4000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="17300,4300,21000" />
+	<Model mesh="cube.mesh" scale=0 position="17000,5000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="17300,5700,21000" />
+	<Model mesh="cube.mesh" scale=0 position="18000,6000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="18700,5700,21000" />
+        <Model mesh="cube.mesh" scale=0 position="19000,5000,21000" />
+      </waypoints>
+      <events>
+        <activity>
+          <EventListener event=guard1trigger4 />
+        </activity>
+      </events>
+    </WaypointPatrolController>
+  </controller>
+</SpaceShip>
+
+<SpaceShip position="17000,5000,21000" lookat="17000,5100,21000" name=secondPatrol visible="true" radarname="Patrol">
+  <events>
+    <visibility>
+      <EventListener event=guard1trigger4 />
+    </visibility>
+  </events>
+  <templates>
+    <Template link=spaceshippirate />
+  </templates>
+  <controller>
+    <WaypointPatrolController alertnessradius=2000 team=1 active=false>
+      <waypoints>
+	<Model mesh="cube.mesh" scale=0 position="17300,5700,21000" />
+	<Model mesh="cube.mesh" scale=0 position="18000,6000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="18700,5700,21000" />
+        <Model mesh="cube.mesh" scale=0 position="19000,5000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="18700,4300,21000" />
+        <Model mesh="cube.mesh" scale=0 position="18000,4000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="17300,4300,21000" />
+	<Model mesh="cube.mesh" scale=0 position="17000,5000,21000" />
+      </waypoints>
+      <events>
+        <activity>
+          <EventListener event=guard1trigger4 />
+        </activity>
+      </events>
+    </WaypointPatrolController>
+  </controller>
+</SpaceShip>
+
+<SpaceShip position="18000,4000,21000" lookat="17000,4000,21000" name=secondPatrol visible="true" radarname="Patrol">
+  <events>
+    <visibility>
+      <EventListener event=guard1trigger4 />
+    </visibility>
+  </events>
+  <templates>
+    <Template link=spaceshippirate />
+  </templates>
+  <controller>
+    <WaypointPatrolController alertnessradius=2000 team=1 active=false>
+      <waypoints>
+	<Model mesh="cube.mesh" scale=0 position="17300,4300,21000" />
+	<Model mesh="cube.mesh" scale=0 position="17000,5000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="17300,5700,21000" />
+	<Model mesh="cube.mesh" scale=0 position="18000,6000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="18700,5700,21000" />
+        <Model mesh="cube.mesh" scale=0 position="19000,5000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="18700,4300,21000" />
+        <Model mesh="cube.mesh" scale=0 position="18000,4000,21000" />
+      </waypoints>
+      <events>
+        <activity>
+          <EventListener event=guard1trigger4 />
+        </activity>
+      </events>
+    </WaypointPatrolController>
+  </controller>
+</SpaceShip>
+
+<SpaceShip position="18000,6000,21000" lookat="19000,6000,21000" name=secondPatrol visible="true" radarname="Patrol">
+  <events>
+    <visibility>
+      <EventListener event=guard1trigger4 />
+    </visibility>
+  </events>
+  <templates>
+    <Template link=spaceshippirate />
+  </templates>
+  <controller>
+    <WaypointPatrolController alertnessradius=2000 team=1 active=false>
+      <waypoints>
+	<Model mesh="cube.mesh" scale=0 position="18700,5700,21000" />
+        <Model mesh="cube.mesh" scale=0 position="19000,5000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="18700,4300,21000" />
+        <Model mesh="cube.mesh" scale=0 position="18000,4000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="17300,4300,21000" />
+	<Model mesh="cube.mesh" scale=0 position="17000,5000,21000" />
+	<Model mesh="cube.mesh" scale=0 position="17300,5700,21000" />
+	<Model mesh="cube.mesh" scale=0 position="18000,6000,21000" />
+      </waypoints>
+      <events>
+        <activity>
+          <EventListener event=guard1trigger4 />
+        </activity>
+      </events>
+    </WaypointPatrolController>
+  </controller>
+</SpaceShip>
+
 
 <!-- ----------------------------------------------------- -->
@@ -404,5 +573,5 @@
 	<?lua
 		dofile("includes/asteroidField.lua")
-		asteroidField(20000, -10000, -10000, 50, 1000, 10000, 40, 0)
+		asteroidField(20000, -10000, -12000, 50, 1000, 10000, 40, 0)
 	?>
 
@@ -421,5 +590,5 @@
 </StaticEntity>
 
-<StaticEntity position="9000,20000,0" yaw=112 pitch=67>
+<StaticEntity position="18000,5000,21000" yaw=112 pitch=67>
   <attached>
     <?lua